//
// hLgXPathɂ₢킹eXg
//

import org.xmldb.api.base.Collection;
import org.xmldb.api.base.Resource;
import org.xmldb.api.base.ResourceIterator;
import org.xmldb.api.base.ResourceSet;
import org.xmldb.api.modules.CollectionManagementService;
import org.xmldb.api.modules.XMLResource;
import org.xmldb.api.modules.XPathQueryService;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;

public class XPathQueryTest  {

  private void start( String file, String xpath )  {

    String colId = "testCollection";  // eXgpRNV
    String docId = "testDocument";    // eXgphLgID

    try  {

      // XindiceI[v
      XMLDB xmldb = new Xindice();
      xmldb.open();
      System.out.println( "XindiceI[v܂" );

      // eXghLgp̃RNVǉ邽߁A
      // CollectionManagementService擾
      Collection col = xmldb.getCollection("xmldb:xindice://localhost:8088/db");
      CollectionManagementService cms =
                xmldb.getCollectionManagementService( col );

      // eXghLgp̃RNVǉ
      col = cms.createCollection( colId );
      System.out.println( "RNV" + colId + "ǉ܂" );

      // eXghLgXMLResourceIuWFNgƂāA
      // Xindiceɒǉ鏀s
      XMLResource resource = 
             (XMLResource)col.createResource(docId, XMLResource.RESOURCE_TYPE);
      String xml = getDocument( file );
      resource.setContent( xml );

      // XMLResourceIuWFNgƂȂeXghLg
      // RNVɒǉ
      col.storeResource(resource);
      System.out.println( "hLg" + docId + "ǉ܂" );

      // ǉeXghLgRNV擾A
      // R\[ɕ\
      String document = (String)col.getResource( docId ).getContent();
      System.out.println( "ǉhLg" );
      System.out.println( document );

      // XPathɂ₢킹s
      System.out.println( "XPath(" + xpath + ")ɂ₢킹s܂" );
      XPathQueryService service =
               (XPathQueryService)col.getService( "XPathQueryService", "1.0" );
      ResourceSet rs = service.query( xpath );

      // XPathɂ₢킹̌ʂʂɕ\
      System.out.println( "₢킹̌" );
      ResourceIterator iterator = rs.getIterator();
      while (iterator.hasMoreResources()) {
         Resource result = (XMLResource)iterator.nextResource();
         System.out.println( (String)result.getContent() );
      }

      // eXghLgRNV폜
      col.removeResource(resource);
      System.out.println( "hLg" + docId + "폜܂" );

      // eXgpɒǉRNV폜
      cms.removeCollection( colId );
      System.out.println( "RNV" + colId + "폜܂" );

      // XindiceN[Y
      xmldb.close();
      System.out.println( "XindiceN[Y܂" );

    }  catch( Exception ex )  {
      ex.printStackTrace( System.out );
    }

  }

  // eXgphLgt@Cǂݍ
  private String getDocument( String file ) throws Exception  {
    StringBuffer doc = new StringBuffer();
    BufferedReader in = new BufferedReader( new FileReader( file ) );
    String line;
    while (( line = in.readLine() ) != null )  doc.append( line );
    in.close();
    return doc.toString();
  }

  public XPathQueryTest()  {}

  public static void main( String[] argv )  {
    if ( argv.length != 2 )  {
      System.out.println( "XindiceXPathQueryServicẽeXgs" );
      System.out.println( "java XPathQueryTest (XMLt@C) (XPath)" );
      System.exit( 1 );
    }
    new XPathQueryTest().start( argv[ 0 ], argv[ 1 ] );
  }

}