<?xml version="1.0"?>
<xsl:transform version="1.0"
               xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:output method="html" indent="yes" />

  <xsl:template match="/">
    <html>
      <head>
        <title>私のブックマーク</title>
      </head>
      <body>
        <table border="1">
          <caption>私のブックマーク</caption>
          <tr><th>サイト名</th><th>URL</th></tr>
          <xsl:apply-templates />
        </table>
      </body>
    </html>
  </xsl:template>

  <xsl:template match="bookmark">
    <tr>
      <td><xsl:value-of select="name" /></td>
      <td>
        <xsl:element name="a">
          <xsl:attribute name="href">
            <xsl:value-of select="url" />
          </xsl:attribute>
          <xsl:value-of select="url" />
        </xsl:element>
      </td>
    </tr>
  </xsl:template>

</xsl:transform>
